Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class FunctionCall

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

Direct Known Subclasses:
  ExtensionFunctionCall, SystemFunction, UserFunctionCall, XPathFunctionCall

    public abstract class FunctionCall

extends Expression

Abstract superclass for calls to system-defined and user-defined functions

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FunctionCall()`

Method Summary
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure.
`Expression[]` | `getArguments()` Get the expressions supplied as actual arguments to the function
`String` | `getDisplayName(NamePool pool)` Diagnostic print of expression structure
`int` | `getFunctionNameCode()` Get the name code of the function being called
`int` | `getNumberOfArguments()` Determine the number of actual arguments supplied in the function call
`Iterator` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `preEvaluate(StaticContext env)` Pre-evaluate a function at compile time.
`Expression` | `promote(PromotionOffer offer)` Promote this expression if possible
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` | `setArguments(Expression[] args)` Method called by the expression parser when all arguments have been supplied
`void` | `setFunctionNameCode(int nc)` Set the name code of the function being called
`Expression` | `simplify(StaticContext env)` Simplify the function call.
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getItemType, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FunctionCall

    public FunctionCall()

Method Detail

### setFunctionNameCode

    public final void setFunctionNameCode(int nc)

  Set the name code of the function being called

### getFunctionNameCode

    public final int getFunctionNameCode()

  Get the name code of the function being called

  Returns:
    the name code as recorded in the name pool

### getNumberOfArguments

    public final int getNumberOfArguments()

  Determine the number of actual arguments supplied in the function call

### setArguments

    public void setArguments(Expression[] args)

  Method called by the expression parser when all arguments have been supplied

### getArguments

    public Expression[] getArguments()

  Get the expressions supplied as actual arguments to the function

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify the function call. Default method is to simplify each of the supplied arguments and evaluate the function if all are now known.

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression. This also calls preEvaluate() to evaluate the function if all the arguments are constant; functions that do not require this behavior can override the preEvaluate method.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### preEvaluate

    public Expression preEvaluate(StaticContext env)
                           throws XPathException

  Pre-evaluate a function at compile time. Functions that do not allow pre-evaluation, or that need access to context information, can override this method.

  Throws:
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### getDisplayName

    public final String getDisplayName(NamePool pool)

  Diagnostic print of expression structure

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Description copied from class: `Expression`
  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.